C------------------
      real*8 function c2g_1_0(y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NLO gluonic constant term of [Nucl. Phys. B383, 525 (1992)]  

      include 'CONSTCOM.'

      c2g_1_0=tr*4*((y**2+(1.-y)**2)*log((1.-y)/y)-1.+8.*y*(1.-y))

      return 
      end
C------------------
      real*8 function c2ns_1_0(y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NLO non-singlet constant term of [Nucl. Phys. B383, 525 (1992)]  

      include 'CONSTCOM.'

      c2ns_1_0=cf*(-2*(1+y)*log(1-y)-2*(1+y**2)/(1-y)*log(y)+6+4*y)

      return 
      end
C------------------
      real*8 function c2ns_1_0_singular(y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NLO non-singlet constant term of [Nucl. Phys. B383, 525 (1992)]  
c (singular piece)

      include 'CONSTCOM.'

      c2ns_1_0_singular=cf*(4.*log(1-y)-3)/(1-y)

      return 
      end
C------------------
      real*8 function c2ns_1_0_local(y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NLO non-singlet constant term of [Nucl. Phys. B383, 525 (1992)]  
c (local piece)

      include 'CONSTCOM.'

      dl1=log(1-y)
      c2ns_1_0_local=cf*(2*dl1**2-3*dl1-4*zeta2-9)

      return 
      end
C------------------
      real*8 function c2ps_2_0(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO pure-singlet constant term of [Nucl. Phys. B588, 345 (2000)]

      dl0=log(z)
      dl1=log(1-z)

      c2ps_2_0=5.290 * (1./z-1.) + 4.310 * dL0**3
     -         - 2.086 * dL0**2 + 39.78 * dL0 - 0.101 * (1.-z) * dL1**3
     -         - (24.75 - 13.80 * z) * dL0**2 * dL1 + 30.23 * dL0 * dL1

      return 
      end
C------------------
      real*8 function c2g_2_0(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO gluonic constant term of [Nucl. Phys. B588, 345 (2000)]

      dl0=log(z)
      dl1=log(1-z)

      c2g_2_0=(1./z * (11.90 + 1494.* dL1) + 5.319 * dL0**3
     -         - 59.48 * dL0**2 - 284.8 * dL0 + 392.4 - 1483.* dL1
     +         + (6.445 + 209.4 * (1.-z)) * dL1**3 - 24.00 * dL1**2
     -         - 724.1 * dL0**2 * dL1 - 871.8 * dL0 * dL1**2)

      return 
      end
C------------------
      real*8 function c2g_2_0_local(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO gluonic constant term of [Nucl. Phys. B588, 345 (2000)]
c  (local piece)

      c2g_2_0_local=-0.28

      return 
      end
C------------------
      real*8 function c2nsp_2_0_nf0(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO non-singlet constant term of [Nucl. Phys. B568, 263 (2000)]
c  (NF-independent piece)

      dl0=log(z)
      dl1=log(1-z)

      c2nsp_2_0_nf0=- 69.59 - 1008.* z
     -          - 2.835 * dL0**3 - 17.08 * dL0**2 + 5.986 * dL0 
     -          - 17.19 * dL1**3 + 71.08 * dL1**2 - 660.7 * dL1
     -          - 174.8 * dL0 * dL1**2 + 95.09 * dL0**2 * dL1

      return 
      end 
C------------------
      real*8 function c2nsp_2_0_nf0_singular(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO non-singlet constant term of [Nucl. Phys. B568, 263 (2000)]
c  (NF-independent, singular piece)

      dl1=log(1-z)
      c2nsp_2_0_nf0_singular=(14.2222*dl1**3-61.3333*dl1**2
     -   -31.105*dl1+188.64)/(1-z)

      return 
      end
C------------------
      real*8 function c2nsp_2_0_nf0_local(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO non-singlet constant term of [Nucl. Phys. B568, 263 (2000)]
c  (NF-independent, local piece)

      dl1=log(1-z)
      c2nsp_2_0_nf0_local=-338.046+14.2222*dl1**4/4.
     -       -61.3333*dl1**3/3.-31.105*dl1*2/2.+188.64*dl1

      return 
      end
C------------------
      real*8 function c2nsp_2_0_nf1(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO non-singlet constant term of [Nucl. Phys. B568, 263 (2000)]
c  (NF^1 piece)

      dl0=log(z)
      dl1=log(1-z)
      c2nsp_2_0_nf1= - 5.691 - 37.91 * z 
     +          + 2.244 * dL0**2 + 5.770 * dL0 
     -          - 1.707 * dL1**2  + 22.95 * dL1
     +          + 3.036 * dL0**2 * dL1 + 17.97 * dL0 * dL1 

      return 
      end
C------------------
      real*8 function c2nsp_2_0_nf1_singular(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO non-singlet constant term of [Nucl. Phys. B568, 263 (2000)]
c  (NF^1, singular piece)

      dl1=log(1-z)
      c2nsp_2_0_nf1_singular=(1.77778*dl1**2-8.5926*dl1+6.3489)/(1-z) 

      return 
      end
C------------------
      real*8 function c2nsp_2_0_nf1_local(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO non-singlet constant term of [Nucl. Phys. B568, 263 (2000)]
c  (NF^1, local piece)

      dl1=log(1-z)
      c2nsp_2_0_nf1_local=46.8405+1.77778*dl1**3/3.
     -     -8.5926*dl1**2/2.+6.3489*dl1

      return 
      end
C------------------
      real*8 function clns_1_0(y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NLO non-singlet constant term of [Nucl. Phys. B383, 525 (1992)]  

      include 'CONSTCOM.'

      clns_1_0=cf*4*y

      return 
      end
C------------------
      real*8 function clg_1_0(y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NLO gluonic constant term of [Nucl. Phys. B383, 525 (1992)]  

      include 'CONSTCOM.'

      clg_1_0=tr*16*y*(1-y)

      return 
      end
C------------------
      real*8 function clns_2_0_nf0(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO non-singlet constant term of [Phys. Lett. B606, 123 (2005)]
c  (NF-independent, regular piece)

      include 'CONSTCOM.'

      dl0=log(z)
      dl1=log(1-z)

      clns_2_0_nf0=128./9.*z*dl1**2-46.5*z*dl1-84.094*dl0*dl1
     -   -37.338+89.53*z+33.82*z**2+z*dl0*(32.9+18.41*dl0)-128./9.*dl0

      return 
      end
C------------------
      real*8 function clns_2_0_nf0_local(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO non-singlet constant term of [Phys. Lett. B606, 123 (2005)]
c  (NF-independent, local piece)

      include 'CONSTCOM.'

      clns_2_0_nf0_local=-0.012

      return 
      end
C------------------
      real*8 function clns_2_0_nf1(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO non-singlet constant term of [Phys. Lett. B606, 123 (2005)]
c  (NF^1 piece)

      include 'CONSTCOM.'

      dl0=log(z)
      dl1=log(1-z)

      clns_2_0_nf1=16./27.*(6*z*dl1-12*z*dl0-25*z+6)

      return 
      end
C------------------
      real*8 function clg_2_0(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO gluon constant term of [Phys. Lett. B606, 123 (2005)]

      include 'CONSTCOM.'

      dl0=log(z)
      dl1=log(1-z)

      clg_2_0=(94.74-49.2*z)*(1-z)*dl1**2+864.8*(1-z)*dl1
     + +1161*z*dl0*dl1+60.06*z*dl0**2+39.66*(1-z)*dl0-5.333*(1./z-1)

      return
      end
C------------------
      real*8 function clps_2_0(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

c The NNLO pure-singlet constant term of [Phys. Lett. B606, 123 (2005)]

      include 'CONSTCOM.'

      dl0=log(z)
      dl1=log(1-z)

      clps_2_0=(15.94 - 5.212 * z) * (1-z)**2 * dL1
     +         + (0.421 + 1.520 * z) * dL0**2 + 28.09 * (1-z) * dL0
     -         - (2.370/z - 19.27) * (1-z)**3

      return
      end

